# webpack性能优化
* 开发环境
* 生产环境

## 开发环境
* 优化打包构建速度
    * HMR 热模块更新
* 优化代码调试
    * source-map

## 生产环境
* 优化打包速度
    * oneOf
    * babel缓存
    * 多进程打包
    * externals
    * dll
* 优化代码运行性能
    * 缓存(hash-chunkhash-contenthash)
    * tree shaking
    * code split
    * 懒加载和预加载
    * pwa 兼容性问题严重
